# Microeconometrics
# CLASS 10
# Programming ML models
# Wiktor Budzinski

library(mvtnorm)
library(ramify)
library(tidyr)
library(dplyr)
library(plm)

rm(list=ls())
setwd("C:\\Users\\budzi\\Documents\\ME QPE\\2024\\Class 10")

## Simple regression
rm(list=ls())
set.seed(1234567)
source("RegCodes.R")

# Betas are 0.5 and -1
data<-GenPanel(1000, 1, 0, 0)
res <- RegExample(y~x1+x2, data)


## Random effects model
rm(list=ls())
set.seed(1234567)
source("MLPanels.R")

# Betas are 0.5 and -1
data<-GenPanel(500, 6, 0, 0)
res <- MLP(y~x1+x2, data, index = "id", type = "RE", TT = 6)

## Fixed effects model
rm(list=ls())
set.seed(1234567)
source("MLPanels.R")
data<-GenPanel(500, 6, 0, -1)
res1<- MLP(y~x1+x2, data, index = "id", type = "RE", TT = 6)
res2 <- MLP(y~x1+x2, data, index = "id", type = "FD", TT = 6)

## Random Effects with AR(1)
rm(list=ls())
set.seed(1234567)
source("MLPanels.R")

data<-GenPanel(500, 6, 0.5, 0)
res1<- MLP(y~x1+x2, data, index = "id", type = "RE", TT = 6)
res2 <- MLP(y~x1+x2, data, index = "id", type = "REAR", TT = 6)
res3 <- MLP(y~x1+x2, data, index = "id", type = "FDAR2", TT = 6)

## Fixed Effects with AR(1)

rm(list=ls())
set.seed(1234567)
source("MLPanels.R")

data<-GenPanel(500, 6, -0.5, 0.5)

#res3 <- MLP(y~x1+x2, data, index = "id", type = "FDAR", TT = 6)
res4 <- MLP(y~x1+x2, data, index = "id", type = "FDAR2", TT = 6)

### Data example

rm(list=ls())
data("RiceFarms", package = "splm")
source("MLPanels.R")

RiceFarms$logoutput <- log(RiceFarms$goutput) # gross output of rice in kg
RiceFarms$logseed <- log(RiceFarms$seed) # seed in kilogram
RiceFarms$loglabor <-   log(RiceFarms$totlabor) # total labor (excluding harvest labor)
RiceFarms$logsize <-   log(RiceFarms$size) # the total area cultivated with rice, measured in hectares

Rice <- pdata.frame(RiceFarms, index = "id")


Eq2 <- logoutput~ lag(logoutput,1) + logseed+loglabor+logsize | lag(logoutput,2:6)
gmm <- pgmm(Eq2, data = Rice, model = "onestep")
summary(gmm)

Eq1 <- logoutput~logseed+loglabor+logsize
res3 <- MLP(Eq1, RiceFarms, index = "id", type = "REAR", TT = 6)
res5 <- MLP(Eq1, RiceFarms, index = "id", type = "FDAR2", TT = 6)
